# -*- coding: utf-8 -*-
"""
Created on Mon Jun  2 14:38:36 2014

@author: Cody
"""
import numpy as np
import matplotlib.pyplot as plt
from scipy.fftpack import fft

def clearall():
    gl = globals().copy()
    for var in gl:
        if var[0] == '_': continue
        if 'func' in str(globals()[var]): continue
        if 'module' in str(globals()[var]): continue
                
        del globals()[var]
            
clearall()
plt.close("all")

def nextpow2(i):
   n = 2
   while n < i: n = n * 2
   return n
   
def pyfft(x_wave, y):

    L = 2 * len(x_wave)
    T = x_wave[1] - x_wave[0]
    Fs = 1 / T
    NFFT = nextpow2(L)

    Yfft = fft(y, NFFT)
    Y = Yfft / L
    freq = Fs / 2 * np.linspace(0, 1, NFFT/2)
    fy = abs(Y[0:NFFT/2])
    
    return (freq, fy)
    
# Define simulation and directory containing simulation
sim1 = 'slotted_box_1'
path1 = 'sim1_results\\'

# Source file

vsource = np.loadtxt('gauss_2ghz.dat')
vts = vsource[:,0]
vs = 0.001 * vsource[:,1]


fs, ys = pyfft(vts, vs)

vsf_peaks = np.zeros(len(fs))

for i in range(len(fs)):
    vsf_peaks[i] = 0.001 / ys[i]
    ys[i] = ys[i] * vsf_peaks[i]

pe1y = np.loadtxt('slotted_box_1nprnumertime1.dat')
te1y = pe1y[:,0]
e1y = 1e6*pe1y[:,1]


fe1, ye1 = pyfft(te1y,e1y)

ye1 = np.multiply(vsf_peaks,ye1)

fig = plt.figure()
fig.set_facecolor('w')
ax = fig.add_axes([0.13, 0.1, 0.8, 0.8])
ax.plot(fe1,20*np.log10(ye1),'r-')
for label in (ax.get_xticklabels() + ax.get_yticklabels()):
    label.set_fontname('Arial')
    label.set_fontsize(13)
ax.set_xlabel('Frequency [HZ]', fontsize = 24, fontname = 'Arial')
ax.set_ylabel('|E| 3m away (dB\muV/m)', fontsize = 24, fontname = 'Arial')
# title('Electric Field At 3 m')
ax.grid(True)
ax.set_xlim([0.7e9, 1.6e9])
ax.set_ylim([0.0, 55])

